#!/bin/sh
# Provider Switcher by hip0
# This is free software you can freely re-distribute it or modify it. Read the GPL for more info on www.gnu.org
# Under GNU Public License ver 2.0 and above

# ip of eth0
ip="213.91.245.1";
string1="$1";
# route cmd path
rt=/sbin/route;

# 1st prov info
FIRST_PROV_NAME="BTK";

FIRST_PROV_IP="213.91.245.1";
FIRST_PROV_GW="213.91.245.254";
FIRST_PROV_DNS="212.36.18.2";
FIRST_PROV_MASK="255.255.255.0";
FIRST_PROV_IFACE="eth0";
# 2nd prov info
SECOND_PROV_NAME="phill";

SECOND_PROV_IP="213.169.57.178";
SECOND_PROV_GW="213.169.57.177";
SECOND_PROV_DNS="217.79.75.17";
SECOND_PROV_MASK="255.255.255.0";
SECOND_PROV_IFACE="eth2";

# ip that we use to say is everything right or not
chk_ip="194.145.63.12";
up_string="up.";
grep_s_string="appears to be up";

# chk for params
chk_params () {

if [ -n "$string1" ]; then

case "$string1" in

$SECOND_PROV_NAME)
chk_cur_prov;
second_prov;;

$FIRST_PROV_NAME)
chk_cur_prov;
first_prov;;
*) 
echo "No such provider. Valid providers are : [$FIRST_PROV_NAME|$SECOND_PROV_NAME]";
exit 0;;
esac

fi

}

# chk cur prov
chk_cur_prov () {
cur_gw=`$rt -n | tail -n 1 | awk '{ print $2 }'`;

if [ "$CUR_PROV" == "$string1" ]; then
echo "Trying to switch from provider:$CUR_PROV to provider:$string1" 
echo ".. ehh kid!";
exit 1;
fi 

if [ "$cur_gw" == "$FIRST_PROV_GW" ] && [ "$CUR_PROV" != "$string1" ]; then
CUR_PROV="$FIRST_PROV_NAME";
NEXT_PROV="$SECOND_PROV_NAME";
fi

if [ "$cur_gw" == "$SECOND_PROV_GW" ] && [ "$CUR_PROV" != "$string1" ]; then
CUR_PROV="$SECOND_PROV_NAME";
NEXT_PROV="$FIRST_PROV_NAME";
fi


}

# chk cur prov state
chk_prov_state () {
nmap_chk_state=`nmap -sP "$chk_ip" | grep "$grep_s_string" | awk '{ print $7 }'`;

if [ "$nmap_chk_state" == "$up_string" ]; then
echo "$CUR_PROV is fine. Everything is up and running Salute!";
exit 0;
fi

if [ -z "$nmap_chk_state" ] && [ "$CUR_PROV" == "$FIRST_PROV_NAME" ]; then 
echo "$CUR_PROV is down. Switching to $NEXT_PROV";
second_prov;

fi

if [ -z "$nmap_chk_state" ] && [ "$CUR_PROV" == "$SECOND_PROV_NAME" ]; then
echo "$CUR_PROV is down. Switching to $NEXT_PROV";
first_prov;

fi
}

# cmds for switching to prov 1
first_prov () {
echo "Switching to $NEXT_PROV.";
( 
ifconfig eth2 down; ifconfig eth0 down;
kill -s 9 `pidof snort`;
ifconfig eth0 $FIRST_PROV_IP netmask $FIRST_PROV_MASK;
#$rt del default gw 213.169.57.177;
#$rt del default gw 217.79.75.20;
#$rt del 217.79.75.20;
#$rt del 213.169.57.177;
sleep 1;
$rt add $FIRST_PROV_GW dev $FIRST_PROV_IFACE;
$rt add default gw $FIRST_PROV_GW ) &>/dev/null
sleep 1;
/etc/rc.d/rc.snort start;
exit 0;
}

# cmds for switching to prov 2
second_prov () {
echo "Switching to $NEXT_PROV.";
(ifconfig eth2 down; ifconfig eth0 down;
kill -s 9 `pidof snort`;
ifconfig eth2 $SECOND_PROV_IP netmask $SECOND_PROV_MASK;
#$rt del default gw 213.169.57.177;
#$rt del default gw 217.79.75.20;
#$rt del 217.79.75.20;
#$rt del 213.169.57.177;
sleep 1;
$rt add $SECOND_PROV_GW dev $SECOND_PROV_IFACE;
$rt add default gw $SECOND_PROV_GW) &>/dev/null
sleep 1;
/etc/rc.d/rc.snort start;
exit 0;
}

# Main function
main () {

chk_cur_prov;
chk_params;
chk_prov_state;

}

main;

# _EOF_
